//+------------------------------------------------------------------+
//|                                             S0_Admissao_v1_0.mqh |
//|                                                            DELTA |
//|                                             HEDGING HORN CAPITAL |
//|                                     https://www.hhcapital.com.br |
//+------------------------------------------------------------------+
#property copyright "Copyright 2023, HEDGING HORN CAPITAL"
#property link      "https://www.hhcapital.com.br"
#property version   "DELTA PRODUCAO v1.0"
#property description "HFT MARKET MAKING. MINI INDICE."

//+===================================================================================================================================================================================+
//| 0 - SESSAO DE CABECALHO / ADMISSAO                                                                                                                                                
//+===================================================================================================================================================================================+
//+------------------------------------------------------------------+
//| 0.1 - IMPORTACOES                                                |
//+------------------------------------------------------------------+
#include <Expert/Expert.mqh>
#include <Trade/Trade.mqh>
#include <Trade/SymbolInfo.mqh>
#include "MarketBook.mqh"

//+------------------------------------------------------------------+
//| 0.2 - OBJETOS OPERACIONAIS                                       |
//+------------------------------------------------------------------+
struct CustomMqlTick
{
   int                  idTick;
   int                  vb0;
   int                  va0;
   int                  bid1;
   int                  ask1;
   int                  vb1;
   int                  va1;
   int                  flag;
   int                  volume;
   datetime             timestamp;
   double               last;
   double               bid0;
   double               ask0;
   string               tipoEvento;
};


struct slot
{
   ulong                idOrdem;
   ulong                idPosicao;
   int                  statusCambio;
   int                  statusMotor;
   int                  ponta;
   int                  state;
   double               qtd;
   double               precoEnvio;
   double               precoAlvo;
   double               precoStop;
   double               spreadEnvio;
   double               spreadAlvo;
   double               spreadStop;
   MqlDateTime          cronometro;
};


struct posicao
{
   ulong                idPosicao;
   int                  ponta;
   double               qtd;
   double               precoMedio;
   double               precoAlvo;
   double               precoStop;
};


struct fluido
{
   int                  q;
   int                  Q;
   int                  t;
   int                  TOr;
   int                  TOe;
   int                  t0d;
   int                  td;
   int                  Td;
   int                  iSlot;
   int                  niveis;
   int                  rajada;
   int                  handlerMA;
   int                  periodoMA;
   int                  intervaloTicks;
   double               c;
   double               media;
   double               precoMedioC;
   double               precoMedioV;
   double               tickMin;
   double               MA[];
   ENUM_TIMEFRAMES      timeframe;
   int                  pontosAlvo;
   double                  stopPercent;
   double               desvioPercent;
   double               spreadOffsetPercent;
};


struct operacao
{
   bool                 chaveSaldoChumbado;
   bool                 chaveEscalonador;
   bool                 chaveRiscoSaldo;
   int                  magic;
   int                  diaAtual;
   int                  diaAnt;
   int                  posicoes_total;
   int                  posicoes_total_prev;
   int                  normalizeDoubleSize;
   int                  tipoPosicao;
   int                  expiraPosicao;   
   int                  countSaldo;
   int                  countFechaDia;
   int                  numeroContratos;
   int                  numeroContratosAcumulado;
   ushort               horarioShort_atual;
   ushort               horarioShort_inicial;
   ushort               horarioShort_final;
   ushort               horarioShort_fechamento;
   double               precoAlvo;
   double               precoStop;
   double               precoEnvio;
   string               handlerNormalizeDoubleSize;  
   MqlDateTime          horarioMQL_inicio;
   MqlDateTime          horarioMQL_final;
   MqlDateTime          horarioMQL_encerramento;
   MqlDateTime          horarioMQL_atual; 
   MqlDateTime          horarioMQL_comprado;
   MqlDateTime          horarioMQL_compra;
   MqlTradeRequest      request;
   MqlTradeResult       result;
   MqlTradeTransaction  transaction;
   MqlTradeCheckResult  check_result;
   CSymbolInfo          simbolo;
   CTrade               negocio;
};

struct gerenciador
{
   double               capitalInicialDia; 
   double               capitalAberto;
   double               capitalFechado;
   double               capitalTotal;
   double               capitalInvestido;
   double               lucroBrutoFechado;
   double               lucroBrutoAberto;
   double               lucroBrutoComposto;
   double               lucroLiquido;
   double               lucroLiquidoAcumulado;
   double               alvoFinanceiro;
   double               stopFinanceiro;
   double               alvoPercentual;
   double               stopPercentual;
};

//+===================================================================================================================================================================================+
//| FIM DO PROGRAMA                                                                                                   
//+===================================================================================================================================================================================+